import { assert, test } from 'vitest';
import { JSONEditor } from "../js/cordra/JSONEditorCordraMods";
import { JsonUtil } from '../js/cordra/JsonUtil';

test("decodeJsonPointerSegment", () => {
    assert.equal(JsonUtil.decodeJsonPointerSegment("foo"), "foo");
    assert.equal(JsonUtil.decodeJsonPointerSegment("foo~1bar"), "foo/bar");
    assert.equal(JsonUtil.decodeJsonPointerSegment("foo~0bar"), "foo~bar");
    assert.equal(JsonUtil.decodeJsonPointerSegment("foo~1~0bar"), "foo/~bar");
    assert.equal(JsonUtil.decodeJsonPointerSegment("foo~0~1bar"), "foo~/bar");
    assert.equal(JsonUtil.decodeJsonPointerSegment("foo~00bar"), "foo~0bar");
    assert.equal(JsonUtil.decodeJsonPointerSegment("foo~01bar"), "foo~1bar");
});

test("encodeJsonPointerSegment", () => {
    assert.equal(JsonUtil.encodeJsonPointerSegment("foo"), "foo");
    assert.equal(JsonUtil.encodeJsonPointerSegment("foo/bar"), "foo~1bar");
    assert.equal(JsonUtil.encodeJsonPointerSegment("foo~bar"), "foo~0bar");
    assert.equal(JsonUtil.encodeJsonPointerSegment("foo/~bar"), "foo~1~0bar");
    assert.equal(JsonUtil.encodeJsonPointerSegment("foo~/bar"), "foo~0~1bar");
    assert.equal(JsonUtil.encodeJsonPointerSegment("foo~0bar"), "foo~00bar");
    assert.equal(JsonUtil.encodeJsonPointerSegment("foo~1bar"), "foo~01bar");
});

test('getJsonAtPointer', () => {
    const obj = { foo: "bar", baz: [ "qux", "quux" ] };
    assert.equal(JsonUtil.getJsonAtPointer(obj, "/foo"), "bar");
    assert.equal(JsonUtil.getJsonAtPointer(obj, "/baz/1"), "quux");

    const jsonObject = {
        identifier: "test/e5e6ba5bdf35203ed2c2",
        name: "Document",
        schema: {
            type: "object",
            title: "Document",
            required: [
                "id",
                "name"
            ],
            properties: {
                id: {
                    type: "string",
                    cordra: {
                        type: {
                            autoGeneratedField: "handle"
                        }
                    }
                },
                name: {
                    type: "string",
                    title: "Name",
                    cordra: {
                        preview: {
                            showInPreview: true,
                            isPrimary: true
                        }
                    }
                },
                description: {
                    type: "string",
                    format: "textarea",
                    title: "Description",
                    cordra: {
                        preview: {
                            showInPreview: true
                        }
                    }
                },
                creationDate: {
                    type: "string",
                    title: "Creation Date",
                    cordra: {
                        type: {
                            autoGeneratedField: "creationDate"
                        }
                    }
                },
                modificationDate: {
                    type: "string",
                    title: "Modification Date",
                    cordra: {
                        type: {
                            autoGeneratedField: "modificationDate"
                        }
                    }
                },
                createdBy: {
                    type: "string",
                    title: "Created By",
                    cordra: {
                        type: {
                            autoGeneratedField: "createdBy"
                        }
                    }
                },
                modifiedBy: {
                    type: "string",
                    title: "Modified By",
                    cordra: {
                        type: {
                            autoGeneratedField: "modifiedBy"
                        }
                    }
                }
            }
        },
        javascript: ""
    };

    let res = JsonUtil.getJsonAtPointer(jsonObject, '/name');
    assert.equal(res, 'Document');
    res = JsonUtil.getJsonAtPointer(jsonObject, '/schema/title');
    assert.equal(res, 'Document');
    res = JsonUtil.getJsonAtPointer(jsonObject, '/schema/required');
    assert.sameMembers(res as string[], jsonObject.schema.required);
    res = JsonUtil.getJsonAtPointer(jsonObject, '/schema/properties/name');
    assert.deepEqual(res, jsonObject.schema.properties.name);
    res = JsonUtil.getJsonAtPointer(jsonObject, '/wrong');
    assert.notExists(res);
});

test("replaceJsonAtPointer", () => {
    const obj = { foo: "bar", baz: [ "qux", "quux" ] };
    assert.equal(obj.foo, "bar");
    JsonUtil.replaceJsonAtPointer(obj, "/foo", "rab");
    assert.equal(obj.foo, "rab");
    assert.equal(obj.baz[1], "quux");
    JsonUtil.replaceJsonAtPointer(obj, "/baz/1", "xuuq");
    assert.equal(obj.baz[1], "xuuq");
});

const schema = {
    properties: {
        "": { type: "string" },
        "a'b]<\"p": { type: "string" },
        "a][b": { type: "string" },
        "a.b": { type: "string" },
        "a": { type: "object",
            properties: {
                b: { type: "string" }
            } },
        ".": { type: "object",
            properties: {
                "": { type: "object",
                    properties: {
                        ".": { type: "string" }
                    } },
                ".": { type: "object",
                    properties: {
                        "": { type: "string" }
                    } }
            } },
        "~/": { type: "string" },
        "array": {
            type: "array",
            items: {
                oneOf: [
                    { type: "string" },
                    { type: "object", properties: { prop: { type: "string" } } }
                ]
            }
        },
        "textarea": {
            type: "string",
            format: "textarea"
        },
        "enum": {
            type: "string",
            enum: ["12"]
        }
    }
};
const json = {
    "": "1",
    "a'b]<\"p": "2",
    "a][b": "3",
    "a.b": "4",
    "a": { b: "5" },
    ".": { "": { ".": "6" }, ".": { "": "7" } },
    "~/": "8",
    "array": [ "9", { prop: "10" } ],
    "textarea": "11",
    "enum": "12"
};

test("inputElementForJsonPointer", () => {
    const div = $('<div/>');
    const jsonEditor = new JSONEditor(div[0], { schema });
    jsonEditor.setValue(json);
    let input = JsonUtil.inputElementForJsonPointer(div, "/");
    assert.equal(input.val(), "1");
    input = JsonUtil.inputElementForJsonPointer(div, "/a'b]<\"p");
    assert.equal(input.val(), "2");
    input = JsonUtil.inputElementForJsonPointer(div, "/a][b");
    assert.equal(input.val(), "3");
    input = JsonUtil.inputElementForJsonPointer(div, "/a.b");
    assert.equal(input.val(), "4");
    input = JsonUtil.inputElementForJsonPointer(div, "/a/b");
    assert.equal(input.val(), "5");
    input = JsonUtil.inputElementForJsonPointer(div, "/.//.");
    assert.equal(input.val(), "6");
    input = JsonUtil.inputElementForJsonPointer(div, "/././");
    assert.equal(input.val(), "7");
    input = JsonUtil.inputElementForJsonPointer(div, "/~0~1");
    assert.equal(input.val(), "8");
    input = JsonUtil.inputElementForJsonPointer(div, "/array/0");
    assert.equal(input.val(), "9");
    input = JsonUtil.inputElementForJsonPointer(div, "/array/1/prop");
    assert.equal(input.val(), "10");
    input = JsonUtil.inputElementForJsonPointer(div, "/textarea");
    assert.equal(input.val(), "11");
    input = JsonUtil.inputElementForJsonPointer(div, "/enum");
    assert.equal(input.val(), "12");
});

test("jsonPointerForElement", () => {
    const div = $('<div/>');
    const jsonEditor = new JSONEditor(div[0], { schema });
    jsonEditor.setValue(json);
    let input = JsonUtil.inputElementForJsonPointer(div, "/");
    assert.equal(JsonUtil.jsonPointerForElement(input), "/");
    input = JsonUtil.inputElementForJsonPointer(div, "/a'b]<\"p");
    assert.equal(JsonUtil.jsonPointerForElement(input), "/a'b]<\"p");
    input = JsonUtil.inputElementForJsonPointer(div, "/a][b");
    assert.equal(JsonUtil.jsonPointerForElement(input), "/a][b");
    input = JsonUtil.inputElementForJsonPointer(div, "/a.b");
    assert.equal(JsonUtil.jsonPointerForElement(input), "/a.b");
    input = JsonUtil.inputElementForJsonPointer(div, "/a/b");
    assert.equal(JsonUtil.jsonPointerForElement(input), "/a/b");
    input = JsonUtil.inputElementForJsonPointer(div, "/.//.");
    assert.equal(JsonUtil.jsonPointerForElement(input), "/.//.");
    input = JsonUtil.inputElementForJsonPointer(div, "/././");
    assert.equal(JsonUtil.jsonPointerForElement(input), "/././");
    input = JsonUtil.inputElementForJsonPointer(div, "/~0~1");
    assert.equal(JsonUtil.jsonPointerForElement(input), "/~0~1");
    input = JsonUtil.inputElementForJsonPointer(div, "/array/0");
    assert.equal(JsonUtil.jsonPointerForElement(input), "/array/0");
    input = JsonUtil.inputElementForJsonPointer(div, "/array/1/prop");
    assert.equal(JsonUtil.jsonPointerForElement(input), "/array/1/prop");
    input = JsonUtil.inputElementForJsonPointer(div, "/textarea");
    assert.equal(JsonUtil.jsonPointerForElement(input), "/textarea");
    input = JsonUtil.inputElementForJsonPointer(div, "/enum");
    assert.equal(JsonUtil.jsonPointerForElement(input), "/enum");
});

test("getDeepProperty", () => {
    const jsonNode = {
        a: {
            b: {
                c: {
                    d: "hi"
                }
            }
        },
        array: [
            {
                something: {
                    else: true
                }
            }
        ]
    };
    const atNothing = JsonUtil.getDeepProperty(jsonNode);
    assert.equal(atNothing, jsonNode);
    const atMissing = JsonUtil.getDeepProperty(jsonNode, "bleh");
    assert.equal(atMissing, null);
    const atMissingDeep = JsonUtil.getDeepProperty(jsonNode, "a", "b", "bleh");
    assert.equal(atMissingDeep, null);
    const works = JsonUtil.getDeepProperty(jsonNode, "a", "b", "c", "d");
    assert.equal(works, "hi");
    const array = JsonUtil.getDeepProperty(jsonNode, "array", "0", "something");
    assert.deepEqual(array, { else: true });
});
